#if !defined(AFX_EMULATORDLG_H__1DCD672B_7A0D_4017_943B_2BE41F33A131__INCLUDED_)
#define AFX_EMULATORDLG_H__1DCD672B_7A0D_4017_943B_2BE41F33A131__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// EmulatorDlg.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CEmulatorDlg dialog
#include "bitmapdialog.h"
#include "togglebutton.h"
#include "bitmapslider.h"
#include "vmrotaryfaderctrl.h"

class CEmulatorDlg : public CBitmapDialog
{
// Construction
public:
	DAC2LISTENER* m_emuproca;
	DAC2LISTENER* m_emuprocb;

	void SetListenerCallback(DAC2LISTENER* proca, DAC2LISTENER* procb);
	CEmulatorDlg(CWnd* pParent = NULL);   // standard constructor

	CPoint		m_ptDragFrom;
	bool		m_bDragging;

	
	CBitmapSlider m_DeckAPitch, m_DeckBPitch;
	CBitmap bitmapPitchChannel, bitmapPitchThumb;

	int m_nDeckAListJogPos, m_nDeckBListJogPos;
	CVMRotaryFaderCtrl m_DeckAJogWheel,m_DeckBJogWheel;
	CBitmap bitmapJogScale, bitmapJogKnob, bitmapJogThumb;

	CToggleButton m_btnClose;
	CToggleButton m_btnDeckALoad, m_btnDeckBLoad;
	CToggleButton m_btnDeckAWaitList, m_btnDeckBWaitList;
	CToggleButton m_btnDeckAShift, m_btnDeckBShift;
	CToggleButton m_btnDeckAFX, m_btnDeckBFX;
	CToggleButton m_btnDeckACueSeekLeft, m_btnDeckBCueSeekLeft;
	CToggleButton m_btnDeckACueSeekRight, m_btnDeckBCueSeekRight;
	CToggleButton m_btnDeckAGroup, m_btnDeckBGroup;
	CToggleButton m_btnDeckACue, m_btnDeckBCue;
	CToggleButton m_btnDeckAPlay, m_btnDeckBPlay;
	CToggleButton m_btnDeckALoop, m_btnDeckBLoop;
	CToggleButton m_btnDeckAMatch, m_btnDeckBMatch;
	CToggleButton m_btnDeckAPitchBendMinus, m_btnDeckBPitchBendMinus;
	CToggleButton m_btnDeckAPitchBendPlus, m_btnDeckBPitchBendPlus;
	CToggleButton m_btnDeckACueLight, m_btnDeckBCueLight;
	CToggleButton m_btnDeckAPlayLight, m_btnDeckBPlayLight;
	CToggleButton m_btnDeckAFXLight, m_btnDeckBFXLight;
	CToggleButton m_btnDeckALoopLight, m_btnDeckBLoopLight;
	CToggleButton m_btnDeckAMatchLight, m_btnDeckBMatchLight;

	CToggleButton DeckACueDigitOne, DeckACueDigitTwo;
	CToggleButton DeckATimeDigitOne, DeckATimeDigitTwo, DeckATimeDigitThree, DeckATimeDigitFour, DeckATimeDigitFive, DeckATimeDigitSix;
	CToggleButton DeckATimeColonOne, DeckATimeColonTwo;
	CToggleButton DeckAProgress[10];
	CToggleButton DeckAElapsed, DeckARemain, DeckASingle, DeckAContinu;
	CToggleButton DeckAPitchNegative, DeckAPitchDecimal, DeckAPitchDigitOne, DeckAPitchDigitTwo, DeckAPitchDigitThree;

	CToggleButton DeckBCueDigitOne, DeckBCueDigitTwo;
	CToggleButton DeckBTimeDigitOne, DeckBTimeDigitTwo, DeckBTimeDigitThree, DeckBTimeDigitFour, DeckBTimeDigitFive, DeckBTimeDigitSix;
	CToggleButton DeckBTimeColonOne, DeckBTimeColonTwo;
	CToggleButton DeckBProgress[10];
	CToggleButton DeckBElapsed, DeckBRemain, DeckBSingle, DeckBContinu;
	CToggleButton DeckBPitchNegative, DeckBPitchDecimal, DeckBPitchDigitOne, DeckBPitchDigitTwo, DeckBPitchDigitThree;


// Dialog Data
	//{{AFX_DATA(CEmulatorDlg)
	enum { IDD = IDD_EMULATOR };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CEmulatorDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CEmulatorDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnClose();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	afx_msg LRESULT OnToggleButtonLDown(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnToggleButtonLUp(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnBitmapSliderMoving(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnBitmapSliderMoved(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRotarySliderMoving(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT OnRotarySliderMoved(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EMULATORDLG_H__1DCD672B_7A0D_4017_943B_2BE41F33A131__INCLUDED_)
