// PictureButton.cpp : implementation file
//

#include "stdafx.h"
#include "EmulatorDlg.h"
#include "ToggleButton.h"
#include "memdc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CToggleButton
IMPLEMENT_DYNAMIC(CToggleButton, CStatic)
	

CToggleButton::CToggleButton()
{
	m_bDown = FALSE;
	m_nState = 1;
	m_cszText = "";
	m_crTextColor = RGB(0,0,0);
	m_crFontColor = RGB(0,0,0);

	m_cszDownBitmap="";
	m_cszOverBitmap="";
	m_cszDefaultBitmap="";
	m_cszToggleBitmap = "";
	m_cszCurrentBitmap = "";

	m_cszAction = "";
	m_nDownBitmap = -1;
	m_nDefaultBitmap = -1;
	m_nToggleBitmap = -1;
	m_nOverBitmap = -1;

	m_nCurrentBitmap = -1;

	m_bToolTips = FALSE;

	m_bCheckBox = FALSE;

	m_cszSmallToolTipContent = "";

}

CToggleButton::~CToggleButton()
{
}


BEGIN_MESSAGE_MAP(CToggleButton, CStatic)
	//{{AFX_MSG_MAP(CToggleButton)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_PAINT()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_MOUSELEAVE, OnMouseLeave)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CToggleButton message handlers

void CToggleButton::OnLButtonDown(UINT nFlags, CPoint point) 
{
	SetFocus();
	SetCapture();
	::SetCursor( AfxGetApp()->LoadCursor(IDC_CUSTOM_HAND));
	
	
	m_crTextColor = RGB(85,122,255);
	SetButton(m_cszDownBitmap, m_nDownBitmap);
	//m_nState = 2;

	if(m_bCheckBox)
	{
		Toggle();
	}

			
	
	m_bDown = TRUE;
	

	::PostMessage(GetParent()->m_hWnd, WM_TOGGLEBUTTON_LBUTTONDOWN, (long)((LPSTR)(LPCTSTR)m_cszAction), (long)((LPSTR)(LPCTSTR)m_cszText));

	//MODIFY HERE LATER
	//CMobileDJProDlg* pDlg = (CMobileDJProDlg*)GetParent();
/*	CWnd* pWnd = GetParent();
	CMobileDJProDlg* pMobileDlg = NULL;
	CSplashScreen* pSplashDlg = NULL;
	CRegister* pRegister = NULL;
	CVideoDevicePopup* pVideoDevicePopup = NULL;

	if(!pWnd->IsKindOf(RUNTIME_CLASS(CMobileDJProDlg)))
	{
		if(pWnd->IsKindOf(RUNTIME_CLASS(CSplashScreen)))
		{
			pSplashDlg = (CSplashScreen*)pWnd;
			pSplashDlg->HandleActions(m_cszAction);
		}
		else if(pWnd->IsKindOf(RUNTIME_CLASS(CVideoDevicePopup)))
		{
			pVideoDevicePopup = (CVideoDevicePopup*)pWnd;
			pVideoDevicePopup->HandleActions(m_cszAction);
		}
		else if(pWnd->IsKindOf(RUNTIME_CLASS(CRegister)))
		{
			pRegister = (CRegister*) pWnd;
			pRegister->HandleActions(m_cszAction);
		}
		else
		{
			pMobileDlg = (CMobileDJProDlg*)pWnd->GetParent();

			//if this is not the main dialog then go one level deeper
			//to see if that works
			if(!pMobileDlg->IsKindOf(RUNTIME_CLASS(CMobileDJProDlg)))
			{
				pMobileDlg = (CMobileDJProDlg*)pWnd->GetParent()->GetParent();
			}

			pMobileDlg->HandleActions(m_cszAction);
		}
	}
	else
	{
		pMobileDlg = (CMobileDJProDlg*)pWnd;
		pMobileDlg->HandleActions(m_cszAction);
	}*/
	

	CStatic::OnLButtonDown(nFlags, point);
}

void CToggleButton::OnLButtonUp(UINT nFlags, CPoint point) 
{

	::SetCursor( AfxGetApp()->LoadCursor(IDC_CUSTOM_HAND));

		::PostMessage(GetParent()->m_hWnd, WM_TOGGLEBUTTON_LBUTTONUP, (long)((LPSTR)(LPCTSTR)m_cszAction), (long)((LPSTR)(LPCTSTR)m_cszText));

	if(m_nState ==1)
	{
		m_crTextColor = RGB(85,122,255);
		SetButton(m_cszOverBitmap, m_nOverBitmap);
	}
	

	ReleaseCapture();
	m_bDown = FALSE;
	CStatic::OnLButtonUp(nFlags, point);
}

void CToggleButton::SetDefaultBitmap(CString cszFilename, UINT nIDResource)
{
	bmDefaultBitmap.DeleteObject();

		if(cszFilename!="")
		{
			m_cszDefaultBitmap = cszFilename;
			if(!CORE_LoadBitmapFromFile(m_cszDefaultBitmap, bmDefaultBitmap))
				AfxMessageBox("Error Loading Bitmap");
		}
		else
		{
			m_nDefaultBitmap = nIDResource;
			bmDefaultBitmap.LoadBitmap(m_nDefaultBitmap);
		}

	
		
		
		


		if(m_nState == 1)
		{
			SetButton(m_cszDefaultBitmap, m_nDefaultBitmap);
		}
		else
		{
			SetButton(m_cszToggleBitmap, m_nToggleBitmap);
		}

		//Draw();
		Invalidate();
	

}

void CToggleButton::SetDownBitmap(CString cszFilename, UINT nIDResource)
{
	bmDownBitmap.DeleteObject();

	if(cszFilename!="")
	{
		m_cszDownBitmap = cszFilename;
		if(!CORE_LoadBitmapFromFile(m_cszDownBitmap, bmDownBitmap))
		AfxMessageBox("Error Loading Bitmap");
	}
	else
	{
		m_nDownBitmap = nIDResource;
		bmDownBitmap.LoadBitmap(m_nDownBitmap);
	}

	
	

}


void CToggleButton::Toggle()
{
	
		if(m_nState == 1)
		{
			SetButton(m_cszToggleBitmap, m_nToggleBitmap);
			m_nState = 2;
		}
		else
		{
			SetButton(m_cszDefaultBitmap, m_nDefaultBitmap);
			m_nState = 1;
		}

}


void CToggleButton::SetButton(CString cszFilename, UINT nIDResource)
{


	if(cszFilename!="")
	{

		m_cszCurrentBitmap = cszFilename;

	}
	else
	{
		m_nCurrentBitmap = nIDResource;
	}
	
	Invalidate();
}

void CToggleButton::SetText(CString cszText)
{
	m_cszText = cszText;
}

void CToggleButton::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	Draw(&dc);
}

void CToggleButton::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(nFlags & MK_LBUTTON)
	{
	}
	else
	{
		m_bDown = FALSE;
	}
	// TODO: Add your message handler code here and/or call default
	TRACKMOUSEEVENT trackmouse;
	trackmouse.cbSize = sizeof(TRACKMOUSEEVENT);
	trackmouse.dwFlags = TME_LEAVE;
	trackmouse.hwndTrack = m_hWnd;
	trackmouse.dwHoverTime = HOVER_DEFAULT;
	TrackMouseEvent(&trackmouse);
	::SetCursor( AfxGetApp()->LoadCursor(IDC_CUSTOM_HAND));
	
	//MODIFY HERE LATER
	//if mouse is not down
	/*if(!m_bDown)
	{
		if(m_bToolTips)
		{
			
			CWnd* pWnd = GetParent();
			if(pWnd->IsKindOf(RUNTIME_CLASS(CMobileDJProDlg)) && m_cszAction.Find("soundeffect") > -1)
			{
				
				CMobileDJProDlg* pDlg = (CMobileDJProDlg*)pWnd;
				pDlg->m_aryStatusDisplay[SOUNDSAMPLESTATUS].SetStatus("    "+m_cszSmallToolTipContent);
			}
			
			
			BOOL bShowToolTips = FALSE;
			if(pWnd->IsKindOf(RUNTIME_CLASS(CMobileDJProDlg)))
			{
				bShowToolTips = ((CMobileDJProDlg*)pWnd)->m_bShowToolTips;
			}
			else
			{
				pWnd = pWnd->GetParent();
				if(pWnd->IsKindOf(RUNTIME_CLASS(CMobileDJProDlg)))
				{
					bShowToolTips = ((CMobileDJProDlg*)pWnd)->m_bShowToolTips;
				}
				else
				{
					pWnd = pWnd->GetParent();
					if(pWnd->IsKindOf(RUNTIME_CLASS(CMobileDJProDlg)))
					{
						bShowToolTips = ((CMobileDJProDlg*)pWnd)->m_bShowToolTips;
					}
				}

			}
			
			if(bShowToolTips)
			{	
				//cancel ballonn toips
				if(!balloontip)
				{
					SetTimer(2, 1500, NULL);					
				}
			}
		}

		if(m_nState == 1)
		{
			m_crTextColor = RGB(85,122,255);
			SetButton(m_cszOverBitmap, m_nOverBitmap);
		}

	}*/

	if(!m_bDown)
	{
		if(m_nState == 1)
		{
			m_crTextColor = RGB(85,122,255);
			SetButton(m_cszOverBitmap, m_nOverBitmap);
		}
	}


	CStatic::OnMouseMove(nFlags, point);
}

void CToggleButton::SetOverBitmap(CString cszFilename, UINT nIDResource)
{
	bmOverBitmap.DeleteObject();

	if(cszFilename!="")
	{
		m_cszOverBitmap = cszFilename;
		if(!CORE_LoadBitmapFromFile(m_cszOverBitmap, bmOverBitmap))
		AfxMessageBox("Error Loading Bitmap");
	}
	else
	{
		m_nOverBitmap = nIDResource;
		bmOverBitmap.LoadBitmap(m_nOverBitmap);
	}

	
	
}

LRESULT CToggleButton::OnMouseLeave(WPARAM wParam, LPARAM lParam)
{
	KillTimer(2);

	//MODIFY HERE LATER
		/*CWnd* pWnd = GetParent();
			if(pWnd->IsKindOf(RUNTIME_CLASS(CMobileDJProDlg)) && m_cszAction.Find("soundeffect") > -1)
			{
				CMobileDJProDlg* pDlg = (CMobileDJProDlg*)pWnd;
				pDlg->m_aryStatusDisplay[SOUNDSAMPLESTATUS].SetStatus("     Sound Samples");
			}*/

	if(m_nState == 1)
	{
		m_crTextColor = m_crFontColor;
		SetButton(m_cszDefaultBitmap, m_nDefaultBitmap);

			/*if(m_bToolTips)
			{
				if(balloontip)
				{
					CPoint point;
					::GetCursorPos(&point);
					//ScreenToClient(&point);

					CRect rect;
					GetClientRect(rect);

					ClientToScreen(&rect);
					if(rect.PtInRect(point))
					{
					}
					else
					{
						CORE_HideTooltip(&balloontip);
						//balloontip.PostMessage(WM_CLOSE);
					}

				}
			}*/

	}

	return TRUE;
}

void CToggleButton::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	SetFocus();
	SetCapture();
	::SetCursor( AfxGetApp()->LoadCursor(IDC_CUSTOM_HAND));
	
	
	m_crTextColor = RGB(85,122,255);
	SetButton(m_cszDownBitmap, m_nDownBitmap);
	//m_nState = 2;

	if(m_bCheckBox)
	{
		Toggle();
	}

			
	
	m_bDown = TRUE;
	

	::PostMessage(GetParent()->m_hWnd, WM_TOGGLEBUTTON_LBUTTONDOWN, (long)((LPSTR)(LPCTSTR)m_cszAction), (long)((LPSTR)(LPCTSTR)m_cszText));


	CStatic::OnLButtonDblClk(nFlags, point);
}

	BOOL CToggleButton::OnEraseBkgnd(CDC* pDC) 
	{
			
		//return TRUE;
		return CStatic::OnEraseBkgnd(pDC);
	}

void CToggleButton::Draw(CDC* pDC)
{
	CRect rect;
	GetClientRect(&rect);
	CMemDC memDC(pDC, rect);
	
	CDC bitmapDC;
	bitmapDC.CreateCompatibleDC(pDC);


	CBitmap* pOldBitmap = NULL;
	
	if(m_cszCurrentBitmap != "")
	{
		if(m_cszCurrentBitmap == m_cszDefaultBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmDefaultBitmap);
		}
		else if(m_cszCurrentBitmap == m_cszOverBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmOverBitmap);
		}
		else if(m_cszCurrentBitmap == m_cszDownBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmDownBitmap);
		}
		else if(m_cszCurrentBitmap == m_cszToggleBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmToggleBitmap);
		}
	}
	else
	{
		
		
		if(m_nCurrentBitmap == m_nDefaultBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmDefaultBitmap);
		}
		else if(m_nCurrentBitmap == m_nOverBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmOverBitmap);
		}
		else if(m_nCurrentBitmap == m_nDownBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmDownBitmap);
		}
		else if(m_nCurrentBitmap == m_nToggleBitmap)
		{
			pOldBitmap = bitmapDC.SelectObject(&bmToggleBitmap);
		}
	}
	
	if(pOldBitmap == NULL)
		AfxMessageBox("null error");

	if(!memDC.BitBlt(rect.left,rect.top,rect.right,rect.bottom,&bitmapDC,0,0,SRCCOPY))
		AfxMessageBox("blit error");
	
	if(m_cszText != "")
	{
		CFont* def_font = memDC.SelectObject(&font);
		memDC.SetTextColor(m_crTextColor);
		memDC.SetBkMode(TRANSPARENT);
		
		
		UINT uFormat = DT_SINGLELINE | DT_NOPREFIX | DT_VCENTER |DT_CENTER | DT_END_ELLIPSIS ;
		
		rect.top+=1;
		memDC.DrawText(m_cszText, &rect, uFormat);
		memDC.SelectObject(def_font);
	}

	//memDC.Draw3dRect(rect, RGB(255,0,0), RGB(255,0,0));
	//memDC.FillSolidRect(rect, RGB(255,0,0));


	bitmapDC.SelectObject(pOldBitmap);
	pOldBitmap = NULL;
	DeleteDC(bitmapDC);

}

void CToggleButton::SetFontColor(COLORREF crColor)
{
	m_crFontColor = crColor;
	m_crTextColor = crColor;
}

void CToggleButton::SetClickAction(CString cszAction)
{
	m_cszAction = cszAction;
}


BOOL CToggleButton::LoadBitmapFromFile(CString cszPath, CBitmap &bitmap)
{
	m_hbitmap=(HBITMAP)LoadImage( AfxGetApp()->m_hInstance, cszPath, IMAGE_BITMAP, 0,0,LR_LOADFROMFILE);
	
	
	if (m_hbitmap == NULL)
		return FALSE;
	
	if (bitmap.Attach(m_hbitmap)==FALSE)
		return FALSE;
	
	
	return TRUE;
}


void CToggleButton::SetToggleBitmap(CString cszImage, UINT nResourceID)
{
	bmToggleBitmap.DeleteObject();

	if(cszImage!="")
	{
		m_cszToggleBitmap = cszImage;
		if(!CORE_LoadBitmapFromFile(m_cszToggleBitmap, bmToggleBitmap))
			AfxMessageBox("Error Loading Bitmap");
	}
	else
	{
		m_nToggleBitmap = nResourceID;
		bmToggleBitmap.LoadBitmap(m_nToggleBitmap);
	}

	
	

}



void CToggleButton::ToggleOn(BOOL bToggleOn)
{
		if(bToggleOn)
		{
			SetButton(m_cszToggleBitmap, m_nToggleBitmap);
			m_nState = 2;
		}
		else
		{
			SetButton(m_cszDefaultBitmap, m_nDefaultBitmap);
			m_crTextColor = m_crFontColor;
			m_nState = 1;
			Invalidate();
			
		}

		if(m_cszToggleBitmap != "")
		{
			bmToggleBitmap.DeleteObject();
			if(!CORE_LoadBitmapFromFile(m_cszToggleBitmap, bmToggleBitmap))
				AfxMessageBox("Error Loading Bitmap");
		}
		else
		{
			bmToggleBitmap.DeleteObject();
			bmToggleBitmap.LoadBitmap(m_nToggleBitmap);
		}
}

void CToggleButton::StartFlash()
{
	SetTimer(1, 250, NULL);
}

void CToggleButton::EndFlash()
{
	ToggleOn(FALSE);
	KillTimer(1);
}

void CToggleButton::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(nIDEvent == 1)
	{
		Toggle();
	}
	
	CStatic::OnTimer(nIDEvent);
}

void CToggleButton::SetToolTips(BOOL bEnable)
{
	m_bToolTips = bEnable;
}

void CToggleButton::SetToolTipTitle(CString cszValue)
{
	m_cszToolTipTitle = cszValue;
}

void CToggleButton::SetToolTipContent(CString cszValue)
{
	m_cszToolTipContent = cszValue;
}

void CToggleButton::SetCheckBox(BOOL bCheckBox)
{
	m_bCheckBox = bCheckBox;
}

void CToggleButton::PreSubclassWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = 8;
	strcpy(lf.lfFaceName, "Sevenet 7");
	font.CreateFontIndirect(&lf);

	CStatic::PreSubclassWindow();
}

void CToggleButton::SetToolTipSmallContent(CString cszFilename)
{
	m_cszSmallToolTipContent = cszFilename;
}

BOOL CToggleButton::IsToggleOn()
{
	if(m_nState == 1)
	{
		return FALSE;
	}
	else if(m_nState == 2)
	{
		return TRUE;
	}
	return FALSE;
}


