// DAC2.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "DAC2.h"

void CALLBACK DeckAPlayFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckA_SetPlayLightB(!bDeckAPlayLightOn);
}

void CALLBACK DeckBPlayFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckB_SetPlayLightB(!bDeckBPlayLightOn);
}

void CALLBACK DeckACueFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckA_SetCueLightB(!bDeckACueLightOn);
}

void CALLBACK DeckBCueFlashTimer(UINT uTimerID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
	DAC2_DeckB_SetCueLightB(!bDeckBCueLightOn);
}

BOOL WINEXPORT DAC2_EventCallbackSet(DAC2PROC* proca, DAC2PROC* procb, DWORD user)
{
	if(bInitialized)
	{
		m_proca = proca;
		m_procb = procb;
		m_dwUser = user;
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

void CALLBACK DAC2ListenerDeckA(LPCTSTR cszCode, BYTE dataarray[])
{
	if(strcmp(cszCode, "905B407F")==0)
	{
		//load down
		m_proca(DAC2_LOAD_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "905B007F")==0)
	{
		//load up
		m_proca(DAC2_LOAD_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9051407F")==0)
	{
		//cue down
		m_proca(DAC2_CUE_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9051007F")==0)
	{
		//cue up
		m_proca(DAC2_CUE_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9050407F")==0)
	{
		//play down
		m_proca(DAC2_PLAY_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9050007F")==0)
	{
		//play up
		m_proca(DAC2_PLAY_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9055407F")==0)
	{
		//waitlist down
		m_proca(DAC2_WAIT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9055007F")==0)
	{
		//waitlist up
		m_proca(DAC2_WAIT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "905A407F")==0)
	{
		//shift down
		m_proca(DAC2_SHIFT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "905A007F")==0)
	{
		//shift up
		m_proca(DAC2_SHIFT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "905C407F")==0)
	{
		//fx down
		m_proca(DAC2_FX_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "905C007F")==0)
	{
		//fx up
		m_proca(DAC2_FX_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9056407F")==0)
	{
		//cue left down
		m_proca(DAC2_CUE_LEFT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9056007F")==0)
	{
		//cue left up
		m_proca(DAC2_CUE_LEFT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9058407F")==0)
	{
		//cue right down
		m_proca(DAC2_CUE_RIGHT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9058007F")==0)
	{
		//cue rght up
		m_proca(DAC2_CUE_RIGHT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9057407F")==0)
	{
		//group down
		m_proca(DAC2_GROUP_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9057007F")==0)
	{
		//group up
		m_proca(DAC2_GROUP_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9059407F")==0)
	{
		//loop down
		m_proca(DAC2_LOOP_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9059007F")==0)
	{
		//loop up
		m_proca(DAC2_LOOP_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9052407F")==0)
	{
		//match down
		m_proca(DAC2_MATCH_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9052007F")==0)
	{
		//match up
		m_proca(DAC2_MATCH_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9053407F")==0)
	{
		//pitch bend plus down
		m_proca(DAC2_PITCHBEND_PLUS_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9053007F")==0)
	{
		//pitch bend plus up
		m_proca(DAC2_PITCHBEND_PLUS_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9054407F")==0)
	{
		//pitch bend minus down
		m_proca(DAC2_PITCHBEND_MINUS_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9054007F")==0)
	{
		//pitch bend minus up
		m_proca(DAC2_PITCHBEND_MINUS_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9061207F")==0)
	{
		//jog left
		m_proca(DAC2_JOG_LEFT, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9061307F")==0)
	{
		//jog right
		m_proca(DAC2_JOG_RIGHT, 0, m_dwUser);
	}
	//else if(cszCode.Mid(0,4) == "E003" && cszCode.GetLength() == 8)
	else if(strncmp(cszCode, "E003", 4) == 0 && strlen(cszCode) == 8)
	{
		TRACE("%s\n", cszCode);
		DWORD nValue= (DWORD)dataarray[2];
		//pitch up
		m_proca(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	//else if(cszCode.Mid(0,4) == "E004" && cszCode.GetLength() == 8)
	else if(strncmp(cszCode, "E004", 4) == 0 && strlen(cszCode) == 8)
	{
		TRACE("%s\n", cszCode);
		DWORD nValue= (DWORD)dataarray[2];
		nValue*=-1;
		//pitch down
		m_proca(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	else if(strcmp(cszCode, "9030007F")==0)
	{
		//seek start
		m_proca(DAC2_SEEK_START, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9030407F")==0)
	{
		//seek end
		m_proca(DAC2_SEEK_END, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9031407F")==0)
	{
		//seek fwd code 1 on
		m_proca(DAC2_SEEK_FWD_1_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9031007F")==0)
	{
		//seek fwd code 1 off
		m_proca(DAC2_SEEK_FWD_1_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9032407F")==0)
	{
		//seek fwd code 2 on
		m_proca(DAC2_SEEK_FWD_2_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9032007F")==0)
	{
		//seek fwd code 2 off
		m_proca(DAC2_SEEK_FWD_2_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9033407F")==0)
	{
		//seek fwd code 3 on
		m_proca(DAC2_SEEK_FWD_3_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9033007F")==0)
	{
		//seek fwd code 3 off
		m_proca(DAC2_SEEK_FWD_3_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9034407F")==0)
	{
		//seek fwd code 4 on
		m_proca(DAC2_SEEK_FWD_4_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9034007F")==0)
	{
		//seek fwd code 4 off
		m_proca(DAC2_SEEK_FWD_4_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9035407F")==0)
	{
		//seek fwd code 5 on
		m_proca(DAC2_SEEK_FWD_5_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9035007F")==0)
	{
		//seek fwd code 5 off
		m_proca(DAC2_SEEK_FWD_5_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9036407F")==0)
	{
		//seek fwd code 6 on
		m_proca(DAC2_SEEK_FWD_6_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9036007F")==0)
	{
		//seek fwd code 6 off
		m_proca(DAC2_SEEK_FWD_6_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9037407F")==0)
	{
		//seek fwd code 7 on
		m_proca(DAC2_SEEK_FWD_7_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9037007F")==0)
	{
		//seek fwd code 7 off
		m_proca(DAC2_SEEK_FWD_7_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9038407F")==0)
	{
		//seek rev code 1 on
		m_proca(DAC2_SEEK_REV_1_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9038007F")==0)
	{
		//seek rev code 1 off
		m_proca(DAC2_SEEK_REV_1_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9039407F")==0)
	{
		//seek rev code 2 on
		m_proca(DAC2_SEEK_REV_2_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9039007F")==0)
	{
		//seek rev code 2 off
		m_proca(DAC2_SEEK_REV_2_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903A407F")==0)
	{
		//seek rev code 3 on
		m_proca(DAC2_SEEK_REV_3_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903A007F")==0)
	{
		//seek rev code 3 off
		m_proca(DAC2_SEEK_REV_3_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903B407F")==0)
	{
		//seek rev code 4 on
		m_proca(DAC2_SEEK_REV_4_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903B007F")==0)
	{
		//seek rev code 4 off
		m_proca(DAC2_SEEK_REV_4_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903C407F")==0)
	{
		//seek rev code 5 on
		m_proca(DAC2_SEEK_REV_5_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903C007F")==0)
	{
		//seek rev code 5 off
		m_proca(DAC2_SEEK_REV_5_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903D407F")==0)
	{
		//seek rev code 6 on
		m_proca(DAC2_SEEK_REV_6_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903D007F")==0)
	{
		//seek rev code 6 off
		m_proca(DAC2_SEEK_REV_6_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903E407F")==0)
	{
		//seek rev code 7 on
		m_proca(DAC2_SEEK_REV_7_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903E007F")==0)
	{
		//seek rev code 7 off
		m_proca(DAC2_SEEK_REV_7_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903F407F")==0)
	{
		//seek rev code 8 on
		m_proca(DAC2_SEEK_REV_8_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "903F007F")==0)
	{
		//seek rev code 8 off
		m_proca(DAC2_SEEK_REV_8_OFF, 0, m_dwUser);
	}
}

void CALLBACK DAC2ListenerDeckB(LPCTSTR cszCode, BYTE dataarray[])
{
	if(strcmp(cszCode, "904B407F")==0)
	{
		//load down
		m_procb(DAC2_LOAD_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "904B007F")==0)
	{
		//load up
		m_procb(DAC2_LOAD_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9041407F")==0)
	{
		//cue down
		m_procb(DAC2_CUE_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9041007F")==0)
	{
		//cue up
		m_procb(DAC2_CUE_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9040407F")==0)
	{
		//play down
		m_procb(DAC2_PLAY_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9040007F")==0)
	{
		//play up
		m_procb(DAC2_PLAY_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9045407F")==0)
	{
		//waitlist down
		m_procb(DAC2_WAIT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9045007F")==0)
	{
		//waitlist up
		m_procb(DAC2_WAIT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "904A407F")==0)
	{
		//shift down
		m_procb(DAC2_SHIFT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "904A007F")==0)
	{
		//shift up
		m_procb(DAC2_SHIFT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "904C407F")==0)
	{
		//fx down
		m_procb(DAC2_FX_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "904C007F")==0)
	{
		//fx up
		m_procb(DAC2_FX_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9046407F")==0)
	{
		//cue left down
		m_procb(DAC2_CUE_LEFT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9046007F")==0)
	{
		//cue left up
		m_procb(DAC2_CUE_LEFT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9048407F")==0)
	{
		//cue right down
		m_procb(DAC2_CUE_RIGHT_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9048007F")==0)
	{
		//cue rght up
		m_procb(DAC2_CUE_RIGHT_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9047407F")==0)
	{
		//group down
		m_procb(DAC2_GROUP_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9047007F")==0)
	{
		//group up
		m_procb(DAC2_GROUP_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9049407F")==0)
	{
		//loop down
		m_procb(DAC2_LOOP_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9049007F")==0)
	{
		//loop up
		m_procb(DAC2_LOOP_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9042407F")==0)
	{
		//match down
		m_procb(DAC2_MATCH_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9042007F")==0)
	{
		//match up
		m_procb(DAC2_MATCH_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9043407F")==0)
	{
		//pitch bend plus down
		m_procb(DAC2_PITCHBEND_PLUS_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9043007F")==0)
	{
		//pitch bend plus up
		m_procb(DAC2_PITCHBEND_PLUS_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9044407F")==0)
	{
		//pitch bend minus down
		m_procb(DAC2_PITCHBEND_MINUS_DOWN, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9044007F")==0)
	{
		//pitch bend minus up
		m_procb(DAC2_PITCHBEND_MINUS_UP, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9060207F")==0)
	{
		//jog left
		m_procb(DAC2_JOG_LEFT, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9060307F")==0)
	{
		//jog right
		m_procb(DAC2_JOG_RIGHT, 0, m_dwUser);
	}
	//else if(cszCode.Mid(0,4) == "E001" && cszCode.GetLength() == 8)
	else if(strncmp(cszCode, "E001", 4) == 0 && strlen(cszCode) == 8)
	{
		
		DWORD nValue= (DWORD)dataarray[2];
		//pitch up
		m_procb(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	//else if(cszCode.Mid(0,4) == "E002" && cszCode.GetLength() == 8)
	else if(strncmp(cszCode, "E002", 4) == 0 && strlen(cszCode) == 8)
	{
		DWORD nValue= (DWORD)dataarray[2];
		nValue*=-1;
		//pitch down
		m_procb(DAC2_PITCH_SLIDER, nValue, m_dwUser);
	}
	else if(strcmp(cszCode, "9020007F")==0)
	{
		//seek start
		m_procb(DAC2_SEEK_START, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9020407F")==0)
	{
		//seek end
		m_procb(DAC2_SEEK_END, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9021407F")==0)
	{
		//seek fwd code 1 on
		m_procb(DAC2_SEEK_FWD_1_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9021007F")==0)
	{
		//seek fwd code 1 off
		m_procb(DAC2_SEEK_FWD_1_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9022407F")==0)
	{
		//seek fwd code 2 on
		m_procb(DAC2_SEEK_FWD_2_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9022007F")==0)
	{
		//seek fwd code 2 off
		m_procb(DAC2_SEEK_FWD_2_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9023407F")==0)
	{
		//seek fwd code 3 on
		m_procb(DAC2_SEEK_FWD_3_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9023007F")==0)
	{
		//seek fwd code 3 off
		m_procb(DAC2_SEEK_FWD_3_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9024407F")==0)
	{
		//seek fwd code 4 on
		m_procb(DAC2_SEEK_FWD_4_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9024007F")==0)
	{
		//seek fwd code 4 off
		m_procb(DAC2_SEEK_FWD_4_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9025407F")==0)
	{
		//seek fwd code 5 on
		m_procb(DAC2_SEEK_FWD_5_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9025007F")==0)
	{
		//seek fwd code 5 off
		m_procb(DAC2_SEEK_FWD_5_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9026407F")==0)
	{
		//seek fwd code 6 on
		m_procb(DAC2_SEEK_FWD_6_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9026007F")==0)
	{
		//seek fwd code 6 off
		m_procb(DAC2_SEEK_FWD_6_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9027407F")==0)
	{
		//seek fwd code 7 on
		m_procb(DAC2_SEEK_FWD_7_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9027007F")==0)
	{
		//seek fwd code 7 off
		m_procb(DAC2_SEEK_FWD_7_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9028407F")==0)
	{
		//seek rev code 1 on
		m_procb(DAC2_SEEK_REV_1_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9028007F")==0)
	{
		//seek rev code 1 off
		m_procb(DAC2_SEEK_REV_1_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9029407F")==0)
	{
		//seek rev code 2 on
		m_procb(DAC2_SEEK_REV_2_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "9029007F")==0)
	{
		//seek rev code 2 off
		m_procb(DAC2_SEEK_REV_2_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902A407F")==0)
	{
		//seek rev code 3 on
		m_procb(DAC2_SEEK_REV_3_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902A007F")==0)
	{
		//seek rev code 3 off
		m_procb(DAC2_SEEK_REV_3_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902B407F")==0)
	{
		//seek rev code 4 on
		m_procb(DAC2_SEEK_REV_4_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902B007F")==0)
	{
		//seek rev code 4 off
		m_procb(DAC2_SEEK_REV_4_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902C407F")==0)
	{
		//seek rev code 5 on
		m_procb(DAC2_SEEK_REV_5_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902C007F")==0)
	{
		//seek rev code 5 off
		m_procb(DAC2_SEEK_REV_5_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902D407F")==0)
	{
		//seek rev code 6 on
		m_procb(DAC2_SEEK_REV_6_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902D007F")==0)
	{
		//seek rev code 6 off
		m_procb(DAC2_SEEK_REV_6_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902E407F")==0)
	{
		//seek rev code 7 on
		m_procb(DAC2_SEEK_REV_7_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902E007F")==0)
	{
		//seek rev code 7 off
		m_procb(DAC2_SEEK_REV_7_OFF, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902F407F")==0)
	{
		//seek rev code 8 on
		m_procb(DAC2_SEEK_REV_8_ON, 0, m_dwUser);
	}
	else if(strcmp(cszCode, "902F007F")==0)
	{
		//seek rev code 8 off
		m_procb(DAC2_SEEK_REV_8_OFF, 0, m_dwUser);
	}
}

DWORD WINAPI CommReader(void *pvData)
{
	
	DWORD dwEventMask;
    int   nSize;
    //char  byBuffer[1024];
	BYTE	byBuffer[1024]={0};
	
    // Set the event mask
    port->SetCommMask(EV_RXCHAR);
	
    // Tell the port to notify us when a read event occurs
    if(!port->WaitCommEvent())
        return 0xFFFFFFFF;      // Error
	
    // Wait for an empty Comm event that signals the COM port object
    // is shutting down.
    do
    {
        // Since this is a separate thread, we can pass TRUE so
        // that the function doesn't return until an event occurs.
        dwEventMask = port->CheckForCommEvent(TRUE);
        if(dwEventMask & EV_RXCHAR)
        {
            // Read as much as possible and display it on the screen
            nSize = port->ReadCommBlock(byBuffer, 1024);
            if(nSize)
			{
				//TRACE("size %d\n", nSize);

				if(nSize >= 18)
				{
				
					//check if it is dac2 here
					char final[100];
					LPSTR cszResponse="";
					for(int i=0; i<nSize; i++)
					{
					
						sprintf(final+i, "%c", (char)byBuffer[i]);
					}
					cszResponse = final;
					
					
					CharUpperBuff(cszResponse, strlen(cszResponse));
					if(strstr(cszResponse, "PCDJ DAC-2")!= NULL)
					{
						bIsDAC2 = TRUE;
					}
					
				
				}
				
				
					
				
				int count = 0;
				while(nSize >= 4)
				{
					BYTE dataarray[4]={0};
					dataarray[0] = byBuffer[count];
					dataarray[1] = byBuffer[count+1];
					dataarray[2] = byBuffer[count+2];
					dataarray[3] = byBuffer[count+3];
					
					
					
					char cszCode[8];
					sprintf(cszCode, "%02X%02X%02X%02X", dataarray[0],dataarray[1],dataarray[2],dataarray[3]);
					
					
					DAC2ListenerDeckA(cszCode, dataarray);
					DAC2ListenerDeckB(cszCode, dataarray);
					nSize-=4;
					count+=4;
				}
					
				
				
				
			}
			// pDoc->ReceiveChars(byBuffer, nSize);
			
            // Set it up to wait for the next event
            port->WaitCommEvent();
        }
		
    } while(dwEventMask);
	
	return 0L;
}

BOOL WINEXPORT DAC2_AutoInit()
{
	TCHAR devices[65535]; 
	
	DWORD nChars = QueryDosDevice(NULL, devices, 65535); 
	
	if(nChars) 
		
	{ 
		
		int i = 0; 
		
		for(;;) 
			
		{ 
			
			TCHAR* pszCurrentDevice = &devices[i]; 
			
			size_t nLen = _tcslen(pszCurrentDevice); 
			
			if(nLen > 3 && _tcsnicmp(pszCurrentDevice, _T("COM"), 3) == 0) 
				
			{ 
				
				if( (pszCurrentDevice[3] >47) && (pszCurrentDevice[3] < 58) ) 
					
				{ 
					
					CString str; 
					
					int nPort = _ttoi(&pszCurrentDevice[3]); 
					
					str.Format("COM%d", nPort); 
					
					if(DAC2_Init(str))
					{
						return TRUE;
					}
					
				} 
				
			} 
			
			while(devices[i] != _T('\0')) 
				
				i++; 
			
			i++; 
			
			if(devices[i] == _T('\0')) 
				
				break; 
			
		} 
		
	}
	
	return FALSE;
}

BOOL WINEXPORT DAC2_Init(LPCTSTR cszPort)
{
	BOOL bSuccess = FALSE;
	
	
	BOOL bStartThread = FALSE;
	LPCTSTR cszEmulate = "emulate";
	
	if(port)
	{
		delete port;
		port = NULL;
	}

	port = new CSerialPort(cszPort);
	
	
	
	
	
	
	if(port && port->IsValid())
	{
		bStartThread = TRUE;
		
        if(bStartThread && !port->StartCommThread(CommReader, 0))
        {
			
            delete port;
            port = NULL;
			
			//delete emulator;
			//emulator = NULL;
			
			DAC2_ErrorCode = DAC2_ERROR_THREAD;
			bInitialized = FALSE;
        }
        else
		{
            //We are all good
		}
		
		
		//send init code to port
		char buf[] = {0xFF, 0x01, 0x01, 0x00}; 
		port->WriteByte(buf, 4);
		/*port->WriteByte(0xFF);
		port->WriteByte(0x01);
		port->WriteByte(0x01);*/
		
		//check for return value to make sure this
		//is the PCDJ DAC-2 and not something else
		//assume it is ok for now
		
		DWORD dwStart = GetTickCount();
		do
		{
			//do nothing
		}while(GetTickCount()-dwStart < 5000 && !bIsDAC2);
		
		if(bIsDAC2)
		{
			
			bInitialized = TRUE;
			bSuccess = TRUE;
		}
		else
		{
			if(port)
			{
				delete port;
				port = NULL;
				
			}
			
			
			DAC2_ErrorCode = DAC2_ERROR_DEVICE;
			bInitialized = FALSE;
		}
		
	}
	else
	{
		if(port)
		{
			delete port;
			port = NULL;
		}
		
		DAC2_ErrorCode = DAC2_ERROR_PORT;
		bInitialized = FALSE;
	}
	
    return bSuccess;
}

BOOL WINEXPORT DAC2_Free()
{
	if(bInitialized)
	{
		if(port)
		{
			delete port;
			port = NULL;
			
		}
		
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

DWORD WINEXPORT DAC2_ErrorGetCode()
{
	return DAC2_ErrorCode;
}

//DECK A

BOOL WINEXPORT DAC2_DeckA_SetCueNumber(int nNumber)
{
	if(bInitialized)
	{
		//leftnum  900000-90000B
		//rightnum 900100-90010B
		if(nNumber == -1)
		{
			//set them to blank
			if(port)
			{
				char buf[] = {0x90, 0x00, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				char buf2[] = {0x90, 0x01, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nNumber == -2)
		{
			//set them to - -
			if(port)
			{
				char buf[] = {0x90, 0x00, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x01, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else if(nNumber <= 99)
		{
			//set them to the number provided
			//ok get the number and parse it
			char cszNumber[2];
			sprintf(cszNumber, "%02d", nNumber);

			char cszDigitOne[2], cszDigitTwo[2];
			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
			BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x00, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x01, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetColons(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x0D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x0D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetTime(int nMinutes, int nSeconds, int nMilliseconds)
{
	if(bInitialized)
	{
		
		char cszNumber[2];
		char cszDigitOne[2], cszDigitTwo[2];
		BYTE xDigitOne, xDigitTwo;
		
		//minutes
		if(nMinutes == -1)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x02, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x03, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else if(nMinutes == -2)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x02, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x03, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else if(nMinutes <= 99)
		{
			sprintf(cszNumber, "%02d", nMinutes);

			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);

			
			if(port)
			{
				char buf[] = {0x90, 0x02, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x03, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//seconds
		if(nSeconds == -1)
		{

			if(port)
			{
				char buf[] = {0x90, 0x04, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x05, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nSeconds == -2)
		{

			if(port)
			{
				char buf[] = {0x90, 0x04, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x05, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nSeconds <= 99)
		{

			sprintf(cszNumber, "%02d", nSeconds);

			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x04, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x05, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//milliseconds
		if(nMilliseconds == -1)
		{
			
			//TRACE("%02d\n",atoi(cszDigitOne), atoi(cszDigitTwo));
			if(port)
			{
				char buf[] = {0x90, 0x06, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x07, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else if(nMilliseconds == -2)
		{
			
			//TRACE("%02d\n",atoi(cszDigitOne), atoi(cszDigitTwo));
			if(port)
			{
				char buf[] = {0x90, 0x06, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x07, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else if(nMilliseconds <= 99)
		{
			sprintf(cszNumber, "%02d", nMilliseconds);

			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			//TRACE("%02d\n",atoi(cszDigitOne), atoi(cszDigitTwo));
			if(port)
			{
				char buf[] = {0x90, 0x06, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
				
				
				char buf2[] = {0x90, 0x07, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetElapsed(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetRemain(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x07, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
		else
		{
			//turn off
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x07, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetSingle(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetPitchNumber(int nNumber)
{
	if(bInitialized)
	{
		if(nNumber <= 199 && nNumber >= -199)
		{
			//set them to the number provided
			//ok get the number and parse it

			char cszNumber[4];
			char cszDigitOne[2], cszDigitTwo[2], cszDigitThree[2];

			
			int nNumberCopy = nNumber;
			nNumber = abs(nNumber);
			
			sprintf(cszNumber, "%02d", nNumber);
			
			
			int nLength = strlen(cszNumber);//cszNumber.GetLength();
			
			//Clear the decimal
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x0E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			
			
			if(nLength == 3)
			{
					cszDigitOne[0] = cszNumber[0];
					cszDigitOne[1] = '\0';

					cszDigitTwo[0] = cszNumber[1];
					cszDigitTwo[1] = '\0';

					cszDigitThree[0] = cszNumber[2];
					cszDigitThree[1] = '\0';

				/*cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				cszDigitThree = cszNumber.GetAt(2);*/
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x08, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				
				
				
				if(port)
				{
					char buf2[] = {0x90, 0x09, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				
				
				
				if(port)
				{
					char buf3[] = {0x90, 0x0A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				
			}
			else if(nLength == 2)
			{

				cszDigitOne[0] = cszNumber[0];
				cszDigitOne[1] = '\0';
				
				cszDigitTwo[0] = cszNumber[1];
				cszDigitTwo[1] = '\0';


				//cszDigitOne = cszNumber.GetAt(0);
				//cszDigitTwo = cszNumber.GetAt(1);
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				
				//clear the 1
				//port->WriteByte(0x90);
				//port->WriteByte(0x08);
				//port->WriteByte(0x00);
				
				if(port)
				{
					char buf[] = {0x90, 0x09, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				
				if(port)
				{
					char buf2[] = {0x90, 0x0A, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				
			}
			
			
			if(nNumberCopy < 0)
			{
				if(nLength == 3)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
				}
				else
				{
					//show negative
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x08, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetPitchNumberf(float fNumber)
{
	if(bInitialized)
	{
		if(fNumber <= 19.9f && fNumber >= -19.9f)
		{
			//set them to the number provided
			//ok get the number and parse it
			
			
			char cszNumber[5];
			char cszDigitOne[2], cszDigitTwo[2], cszDigitThree[2], cszDigitFour[3];
			
			float fNumberCopy = fNumber;
			if(fNumber < 0.0f)
				fNumber = fNumber*-1;
			
			
			sprintf(cszNumber, "%.1f", fNumber);
			
			int nLength = strlen(cszNumber);//cszNumber.GetLength();
			
			
			if(nLength == 4)
			{
				cszDigitOne[0] = cszNumber[0];
				cszDigitOne[1] = '\0';
				
				cszDigitTwo[0] = cszNumber[1];
				cszDigitTwo[1] = '\0';

				cszDigitFour[0] = cszNumber[3];
				cszDigitFour[1] = '\0';

				/*cszDigitOne = cszNumber.GetAt(0);
				cszDigitTwo = cszNumber.GetAt(1);
				//cszDigitThree = cszNumber.GetAt(2);
				cszDigitFour = cszNumber.GetAt(3);*/
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				//BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x08, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				
				if(port)
				{
					char buf2[] = {0x90, 0x09, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				
				//decimal
				if(port)
				{
					char buf3[] = {0x90, 0x0B, 0x0E, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				
				if(port)
				{
					char buf4[] = {0x90, 0x0A, xDigitFour, 0x00}; 
					port->WriteByte(buf4, 4);
				}
				
				
			}
			else if(nLength == 3)
			{
				cszDigitOne[0] = cszNumber[0];
				cszDigitOne[1] = '\0';
				
				cszDigitThree[0] = cszNumber[2];
				cszDigitThree[1] = '\0';


				/*cszDigitOne = cszNumber.GetAt(0);
				//cszDigitTwo = cszNumber.GetAt(1);
				cszDigitThree = cszNumber.GetAt(2);
				//cszDigitFour = cszNumber.GetAt(3);*/
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				//BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				//BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				//port->WriteByte(0x90);
				//port->WriteByte(0x08);
				//port->WriteByte(xDigitOne);
				
				if(port)
				{
					char buf[] = {0x90, 0x09, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				
				//decimal
				if(port)
				{
					char buf2[] = {0x90, 0x0B, 0x0E, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				
				if(port)
				{
					char buf3[] = {0x90, 0x0A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				
			}
			
			
			if(fNumberCopy < 0)
			{
				if(nLength == 4)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
				}
				else
				{
					//show negative
					if(port)
					{
						char buf[] = {0x90, 0x08, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x08, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetProgress(int nPercent)
{
	if(bInitialized)
	{
		DAC2_DeckA_ClearProgress();
		//there are 5 slots left and 5 slots right
		//for a total of 10 so we must do it right
		int nScalePercent = nPercent / 10;
		if(nScalePercent == 1)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x30, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 2)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x38, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 3)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x3C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 4)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x3E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 5)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x3F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 6)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x50, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 7)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x58, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 8)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x5C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 9)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x5E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 10)
		{
			if(port)
			{
				char buf[] = {0x90, 0x0F, 0x5F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_ClearProgress()
{
	if(bInitialized)
	{
		if(port)
		{
			char buf[] = {0x90, 0x0F, 0x20, 0x00}; 
			port->WriteByte(buf, 4);
		}
		
		
		if(port)
		{
			char buf2[] = {0x90, 0x0F, 0x00, 0x00}; 
			port->WriteByte(buf2, 4);
		}
		
		
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetCueLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckA_SetFlashCueLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			bDeckACueLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			bDeckACueLightOn = FALSE;
			DAC2_DeckA_SetFlashCueLight(FALSE);
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetCueLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			bDeckACueLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x01, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			bDeckACueLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetPlayLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckA_SetFlashPlayLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			bDeckAPlayLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckAPlayLightOn = FALSE;
			DAC2_DeckA_SetFlashPlayLight(FALSE);
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetPlayLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			bDeckAPlayLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x00, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckAPlayLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetFXLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x09, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x09, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetMatchLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x02, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x02, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckA_SetLoopLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x08, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x08, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetFlashPlayLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckAPlayFlashTimer)
				dwDeckAPlayFlashTimer = timeSetEvent(250,250,&DeckAPlayFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckAPlayFlashTimer)
				timeKillEvent(dwDeckAPlayFlashTimer);

			dwDeckAPlayFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckA_SetFlashCueLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckACueFlashTimer)
				dwDeckACueFlashTimer = timeSetEvent(250,250,&DeckACueFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckACueFlashTimer)
				timeKillEvent(dwDeckACueFlashTimer);

			dwDeckACueFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

//DECK B


BOOL WINEXPORT DAC2_DeckB_SetCueNumber(int nNumber)
{
	if(bInitialized)
	{
		//leftnum  900000-90000B
		//rightnum 900100-90010B
		if(nNumber == -1)
		{
			//set them to blank
			if(port)
			{
				char buf[] = {0x90, 0x10, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x11, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
			
		}
		else if(nNumber == -2)
		{
			//set them to - -
			if(port)
			{
				char buf[] = {0x90, 0x10, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x11, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nNumber <= 99)
		{
			//set them to the number provided
			//ok get the number and parse it

			char cszNumber[2];
			sprintf(cszNumber, "%02d", nNumber);

			char cszDigitOne[2], cszDigitTwo[2];
			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			
			BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
			BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x10, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x11, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetColons(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x1D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x1D, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetTime(int nMinutes, int nSeconds, int nMilliseconds)
{
	if(bInitialized)
	{
		char cszNumber[2];
		char cszDigitOne[2], cszDigitTwo[2];
		BYTE xDigitOne, xDigitTwo;
		
		//minutes
		if(nMinutes == -1)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x12, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x13, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nMinutes == -2)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x12, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x13, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nMinutes <= 99)
		{
			sprintf(cszNumber, "%02d", nMinutes);

			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x12, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(port)
			{
				char buf2[] = {0x90, 0x13, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//seconds
		if(nSeconds == -1)
		{

			if(port)
			{
				char buf[] = {0x90, 0x14, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x15, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nSeconds == -2)
		{

			if(port)
			{
				char buf[] = {0x90, 0x14, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x15, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nSeconds <= 99)
		{
			sprintf(cszNumber, "%02d", nSeconds);

			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x14, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x15, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
		
		//milliseconds
		if(nMilliseconds == -1)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x16, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x17, 0x0B, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nMilliseconds == -2)
		{
			
			if(port)
			{
				char buf[] = {0x90, 0x16, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x17, 0x0A, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else if(nMilliseconds <= 99)
		{
			sprintf(cszNumber, "%02d", nMilliseconds);

			cszDigitOne[0] = cszNumber[0];
			cszDigitOne[1] = '\0';
			
			cszDigitTwo[0] = cszNumber[1];
			cszDigitTwo[1] = '\0';
			
			xDigitOne = _tcstol(cszDigitOne, 0, 16);
			xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
			
			if(port)
			{
				char buf[] = {0x90, 0x16, xDigitOne, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			if(port)
			{
				char buf2[] = {0x90, 0x17, xDigitTwo, 0x00}; 
				port->WriteByte(buf2, 4);
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetElapsed(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x16, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x16, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetRemain(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x17, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x17, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetSingle(BOOL bShow)
{
	if(bInitialized)
	{
		if(bShow)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0B, 0x15, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x15, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetPitchNumber(int nNumber)
{
	if(bInitialized)
	{
		if(nNumber <= 199 && nNumber >= -199)
		{
			//set them to the number provided
			//ok get the number and parse it

			char cszNumber[4];
			char cszDigitOne[2], cszDigitTwo[2], cszDigitThree[2];

			
			int nNumberCopy = nNumber;
			nNumber = abs(nNumber);
			
			sprintf(cszNumber, "%02d", nNumber);
			
			
			int nLength = strlen(cszNumber);//cszNumber.GetLength();
			
			//Clear the decimal
			if(port)
			{
				char buf[] = {0x90, 0x0C, 0x1E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
			
			if(nLength == 3)
			{
				cszDigitOne[0] = cszNumber[0];
					cszDigitOne[1] = '\0';

					cszDigitTwo[0] = cszNumber[1];
					cszDigitTwo[1] = '\0';

					cszDigitThree[0] = cszNumber[2];
					cszDigitThree[1] = '\0';
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x18, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				
				if(port)
				{
					char buf2[] = {0x90, 0x19, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				
				if(port)
				{
					char buf3[] = {0x90, 0x1A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
				
			}
			else if(nLength == 2)
			{
				cszDigitOne[0] = cszNumber[0];
				cszDigitOne[1] = '\0';
				
				cszDigitTwo[0] = cszNumber[1];
				cszDigitTwo[1] = '\0';
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				
				//clear the 1
				////port->writeByte(0x90);
				////port->writeByte(0x08);
				////port->writeByte(0x00);
				
				if(port)
				{
					char buf[] = {0x90, 0x19, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				
				if(port)
				{
					char buf2[] = {0x90, 0x1A, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
			}
			
			
			if(nNumberCopy < 0)
			{
				if(nLength == 3)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
				}
				else
				{
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
					//show negative
					
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x18, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetPitchNumberf(float fNumber)
{
	if(bInitialized)
	{
		if(fNumber <= 19.9f && fNumber >= -19.9f)
		{
			//set them to the number provided
			//ok get the number and parse it
			
			
			char cszNumber[5];
			char cszDigitOne[2], cszDigitTwo[2], cszDigitThree[2], cszDigitFour[3];
			
			float fNumberCopy = fNumber;
			if(fNumber < 0.0f)
				fNumber = fNumber*-1;
			
			
			sprintf(cszNumber, "%.1f", fNumber);
			
			int nLength = strlen(cszNumber);//cszNumber.GetLength();
			
			
			if(nLength == 4)
			{
				cszDigitOne[0] = cszNumber[0];
				cszDigitOne[1] = '\0';
				
				cszDigitTwo[0] = cszNumber[1];
				cszDigitTwo[1] = '\0';

				cszDigitFour[0] = cszNumber[3];
				cszDigitFour[1] = '\0';

				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				//BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				if(port)
				{
					char buf[] = {0x90, 0x18, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				
				if(port)
				{
					char buf2[] = {0x90, 0x19, xDigitTwo, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				if(port)
				{
					char buf3[] = {0x90, 0x0B, 0x1E, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				//decimal
				
				if(port)
				{
					char buf4[] = {0x90, 0x1A, xDigitFour, 0x00}; 
					port->WriteByte(buf4, 4);
				}
				
			}
			else if(nLength == 3)
			{
				cszDigitOne[0] = cszNumber[0];
				cszDigitOne[1] = '\0';
				
				cszDigitThree[0] = cszNumber[2];
				cszDigitThree[1] = '\0';
				
				BYTE xDigitOne = _tcstol(cszDigitOne, 0, 16);
				//BYTE xDigitTwo = _tcstol(cszDigitTwo, 0, 16);
				BYTE xDigitThree = _tcstol(cszDigitThree, 0, 16);
				//BYTE xDigitFour = _tcstol(cszDigitFour, 0, 16);
				
				////port->writeByte(0x90);
				////port->writeByte(0x08);
				////port->writeByte(xDigitOne);
				
				if(port)
				{
					char buf[] = {0x90, 0x19, xDigitOne, 0x00}; 
					port->WriteByte(buf, 4);
				}
				
				if(port)
				{
					char buf2[] = {0x90, 0x0B, 0x1E, 0x00}; 
					port->WriteByte(buf2, 4);
				}
				
				//decimal
				
				if(port)
				{
					char buf3[] = {0x90, 0x1A, xDigitThree, 0x00}; 
					port->WriteByte(buf3, 4);
				}
				
			}
			
			
			if(fNumberCopy < 0)
			{
				if(nLength == 4)
				{
					//show negative with one
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0D, 0x00}; 
						port->WriteByte(buf, 4);
					}
					
				}
				else
				{
					//show negative
					if(port)
					{
						char buf[] = {0x90, 0x18, 0x0A, 0x00}; 
						port->WriteByte(buf, 4);
					}
				}
			}
			else
			{
				//take away negative
				if(port)
				{
					char buf[] = {0x90, 0x18, 0x0B, 0x00}; 
					port->WriteByte(buf, 4);
				}
			}
			
		}
		else
		{
			DAC2_ErrorCode = DAC2_ERROR_RANGE;
			return FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetProgress(int nPercent)
{
	if(bInitialized)
	{
		DAC2_DeckB_ClearProgress();
		//there are 5 slots left and 5 slots right
		//for a total of 10 so we must do it right
		int nScalePercent = nPercent / 10;
		if(nScalePercent == 1)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x30, 0x00}; 
				port->WriteByte(buf, 4);
			}
		
		}
		else if(nScalePercent == 2)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x38, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 3)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x3C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 4)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x3E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 5)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x3F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 6)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x50, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 7)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x58, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 8)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x5C, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 9)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x5E, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else if(nScalePercent == 10)
		{
			if(port)
			{
				char buf[] = {0x90, 0x1F, 0x5F, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_ClearProgress()
{
	if(bInitialized)
	{
		if(port)
		{
			char buf[] = {0x90, 0x1F, 0x20, 0x00}; 
			port->WriteByte(buf, 4);
		}
		
		
		if(port)
		{
			char buf2[] = {0x90, 0x1F, 0x00, 0x00}; 
			port->WriteByte(buf2, 4);
		}
		
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetPlayLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckB_SetFlashPlayLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBPlayLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBPlayLightOn = FALSE;
			DAC2_DeckB_SetFlashPlayLight(FALSE);
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}


BOOL DAC2_DeckB_SetPlayLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBPlayLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x04, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBPlayLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetCueLight(int nState)
{
	if(bInitialized)
	{
		if(nState == 2)
		{
			DAC2_DeckB_SetFlashCueLight(TRUE);
		}
		else if(nState == 1)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBCueLightOn = TRUE;
		}
		else if(nState == 0)
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBCueLightOn = FALSE;
			DAC2_DeckB_SetFlashCueLight(TRUE);
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckB_SetCueLightB(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBCueLightOn = TRUE;
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x05, 0x00}; 
				port->WriteByte(buf, 4);
			}
			

			bDeckBCueLightOn = FALSE;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetFXLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x0B, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetMatchLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x06, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL WINEXPORT DAC2_DeckB_SetLoopLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(port)
			{
				char buf[] = {0x90, 0x0D, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
		else
		{
			//turn off	
			if(port)
			{
				char buf[] = {0x90, 0x0E, 0x0A, 0x00}; 
				port->WriteByte(buf, 4);
			}
			
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}



BOOL DAC2_DeckB_SetFlashPlayLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckBPlayFlashTimer)
				dwDeckBPlayFlashTimer = timeSetEvent(250,250,&DeckBPlayFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckBPlayFlashTimer)
				timeKillEvent(dwDeckBPlayFlashTimer);

			dwDeckBPlayFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}

BOOL DAC2_DeckB_SetFlashCueLight(BOOL bOn)
{
	if(bInitialized)
	{
		if(bOn)
		{
			//turn on
			if(!dwDeckBCueFlashTimer)
				dwDeckBCueFlashTimer = timeSetEvent(250,250,&DeckBCueFlashTimer, 0, TIME_PERIODIC);
		}
		else
		{
			//turn off	
			if(dwDeckBCueFlashTimer)
				timeKillEvent(dwDeckBCueFlashTimer);

			dwDeckBCueFlashTimer = 0;
		}
	}
	else
	{
		DAC2_ErrorCode = DAC2_ERROR_INIT;
		return FALSE;
	}
	
	return TRUE;
}









BOOL WINEXPORT DAC2_SetCueNumber(int nDevice, int nNumber)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetCueNumber(nNumber);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetCueNumber(nNumber);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetColons(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetColons(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetColons(bShow);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetTime(int nDevice, int nMinutes, int nSeconds, int nMilliseconds)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetTime(nMinutes, nSeconds, nMilliseconds);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetTime(nMinutes, nSeconds, nMilliseconds);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetElapsed(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetElapsed(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetElapsed(bShow);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetRemain(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetRemain(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetRemain(bShow);
	}

	return FALSE;
}


BOOL WINEXPORT DAC2_SetSingle(int nDevice, BOOL bShow)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetSingle(bShow);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetSingle(bShow);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetPitchNumber(int nDevice, int nNumber)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPitchNumber(nNumber);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPitchNumber(nNumber);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetPitchNumberf(int nDevice, float fNumber)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPitchNumberf(fNumber);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPitchNumberf(fNumber);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetProgress(int nDevice, int nPercent)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetProgress(nPercent);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetProgress(nPercent);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_ClearProgress(int nDevice)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_ClearProgress();
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_ClearProgress();
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetCueLight(int nDevice, int nState)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetCueLight(nState);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetCueLight(nState);
	}

	return FALSE;
}

BOOL DAC2_SetCueLightB(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetCueLightB(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetCueLightB(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetPlayLight(int nDevice, int nState)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPlayLight(nState);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPlayLight(nState);
	}

	return FALSE;
}

BOOL DAC2_SetPlayLightB(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetPlayLightB(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetPlayLightB(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetFXLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetFXLight(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetFXLight(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetMatchLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetMatchLight(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetMatchLight(bOn);
	}

	return FALSE;
}

BOOL WINEXPORT DAC2_SetLoopLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetLoopLight(bOn);
	}
	else if(nDevice==1)
	{
		return DAC2_DeckB_SetLoopLight(bOn);
	}

	return FALSE;
}

BOOL DAC2_SetFlashPlayLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetFlashPlayLight(bOn);
	}
	else if(nDevice == 1)
	{
		return DAC2_DeckB_SetFlashPlayLight(bOn);
	}
	
	return TRUE;
}

BOOL DAC2_SetFlashCueLight(int nDevice, BOOL bOn)
{
	if(nDevice==0)
	{
		return DAC2_DeckA_SetFlashCueLight(bOn);
	}
	else if(nDevice == 1)
	{
		return DAC2_DeckB_SetFlashCueLight(bOn);
	}
	
	return TRUE;
}